extends ../layouts/navbar
include ../components/successerrorbox

block content
    if adminMode
        h1 Manage Courses (Admin)
    else
        h1 View Courses

    +successerror(sucmsg, errmsg)

    table#courseTable.table.clickable.w-100

    include ../meta/datatables
    include ../meta/momentjs

    script.
        $(document).ready(() => {
            let table;
            let buttons = [
                {
                    text: 'Show Active',
                    action: (e, dt, button) => {
                        if (table.column(5).search() === 'true') { button.text('Show Active'); table.column(5).search('').draw();}
                        else { button.text('Show All'); table.column(5).search('true').draw(); }
                    }
                },
                {
                    text: 'Show Managed',
                    action: (e, dt, button) => {
                        if (table.column(4).search() === 'true') { button.text('Show Managed'); table.column(4).search('').draw(); }
                        else { button.text('Show All'); table.column(4).search('true').draw(); }
                    }
                },
                {
                    text: 'Add Course',
                    action: () => {window.location.href = '/course/add'}
                }
                ];
            if (#{!hasPermission('addcourse')}) buttons.splice(2, 1);
            table = $('#courseTable').DataTable({
                ajax: '#{dataLink}',
                dom: 'Brftilp',
                buttons: buttons,
                responsive: true,
                select: 'single',
                deferRender: true,
                columns: [
                    { title: "Course Code", data: 'code'},
                    { title: "Course Name", data: 'name'},
                    { title: "Start Date", data: null, render: (data) => { return moment(new Date(data.ts)).format('DD MMMM YYYY'); }},
                    { title: "End Date", data: null, render: (data) => { return (data.te) ? moment(new Date(data.te)).format('DD MMMM YYYY') : 'No End Date'; }},
                    { title: "canedit", data: 'canEdit', visible: false },
                    { title: "isactive", data: 'isActive', visible: false },
                    { title: "Actions",
                        className: 'details-control',
                        orderable: false,
                        data: null,
                        render: (data) => {
                            if (!data.canEdit) return 'No Actions';

                            return `<a href="/course/edit/${data.id}" class="btn btn-outline-secondary" data-toggle="tooltip" title="Edit Course" data-placement="bottom"><i class="fa fa-edit"></i></a>` +
                                `<a href="/course/assign/${data.id}" class="btn btn-outline-secondary ml-1" data-toggle="tooltip" title="Assign User to Course" data-placement="bottom"><i class="fa fa-user-plus"></i></a>`;
                        },
                    }
                ]
            });

            $("body").tooltip({ selector: '[data-toggle=tooltip]', trigger: 'hover' });
            table.on('select', (e,dt,type,indexes) => {
                let rowData = table.rows( indexes ).data().toArray()[0];
                window.location.href = `/course/info/${rowData.id}`;
            });
            table.on('draw', () => MathJax.typesetPromise())
        });
